#include <iostream>
#include <vector>
#include <string>
#include <sstream>
#include <set>
#include <math.h>

#include "definitions.h"
//#include "recognition.h"
#include "bfs.h"
#include "read_in_graph.h"
#include "hammack_edgN_Nstar.h"
//#include "squareProperty.h" 

#include "decompose_strong/blow_down.h"
#include "decompose_strong/init_stuff.h"
#include "decompose_strong/print_stuff.h"
#include "decompose_strong/decompose.h"
#include "decompose_strong/CartSk.h"
#include "decompose_strong/test_and_combine.h"
#include "decompose_strong/pomp_up.h"


#include <boost/config.hpp>
#include <boost/graph/adjacency_list.hpp>
#include <boost/graph/graph_utility.hpp>
#include <boost/graph/connected_components.hpp>

using namespace std;
using namespace boost;



//int recognition(list<myGraph>& List_Of_Factors, myGraph& G, myGraph& ColoredCartSk, double& percentPrimeN,
//				int& prN, int& sigmasize){

/**for approx products only -- use only NON-prime 1-N, edgeN and Nstar 
   here all 1-N and all Nstar are used, 
   and only non-prime edgeN, since they were covered at the end
   by Nstar 
   to change these cases : check if(CASE != 2) cases in
   int main(int argc, char *argv[]) (line 135)
   and 
   in    hammack_edgN_Nstar.cpp in 
	     bool checkDispens_in_edgeN_and_PFD
	and  void PFD_N_star */

int main(int argc, char *argv[]){

	myGraph graph;
	
	bool FileExists = true;
	ReadAdjacencyList(argv[1], graph, FileExists);
	if(!FileExists) return 0;
	
	cout << "\nInputGraph H: " << endl;
	print_graph(graph);

	myGraph ColoredCartSk;
	myGraph H, G; /**G is the thin graph, which comes from graph*/
	vector<int> c(num_vertices(graph));
	VecOfSets S_global;
	int gcd;
	bool only_complete_factors;
	vector<int> how_many;
	
	bool pumped_up = init_thin_graph(graph,H,G,S_global,c,gcd,only_complete_factors,how_many);
	
	print_OnlyCompleteFactors_and_QuotientGraph(only_complete_factors, gcd, G, graph);
	if(only_complete_factors) return 0;

	assign_edID(G);/*in init-stuff*/

	vector<int> sigma;	//covering sequence
	vector< set<int> > N;
	init_BFS_on_backbone_vertices(G,N,sigma);
	
	/*Tue 12 Jan 2010 03:25:47 PM CET */
	mark_edges_unchecked(G);  /**first all weight w = 2, later w=1 if Cartesian, w=0 if nonCartesian*/ 								  /**remaining edges with with w=2 "unchecked" whether cart or not (S1cond fails), */
							  /**	on this edges Hammack-approach and Nstar*/
	/**before mark_edges_noncartesian(G);*/
	/*first all weight w = 0, later w=1 if Cartesian and S1 condition,*/
	/*w=2 if not possible to decide whether cart or not, 
	  on this edges Hammack-approach and Nstar*/
	/*Tue 12 Jan 2010 03:25:47 PM CET */

	print_Sigma(sigma);

	vector< vector<int> > VertexIDs(num_vertices(G));
	int count_prime_N = 0;
	int count_nonThin_N = 0;
	int count_Thin_N = 0;
	int count_edgeN = 0;	
	
	vector< vector<int> > all_colors_of_edge(num_edges(G));
	for(unsigned int i = 0; i<num_edges(G);i++)
		all_colors_of_edge[i].clear();

	
	//myGraph CartRel; /**edges of CartSk to vertices, connected if in prod-class*/
	myGraph ColorGraph;
	vector< bool > is_thinN(num_vertices(G));
	for(unsigned int i=0; i<sigma.size();++i) is_thinN[i] = false;
	
	bool proper_color_conti = true;
	for(unsigned int i=0; i<sigma.size();++i){
		int current_v = sigma[i];
		vector<int> V_ID; /**V_ID[v] = w , v \in N, w \in G*/
		myGraph induced_N;
		
		init_induced_neighborhood(G, N, induced_N, current_v, V_ID);
		VertexIDs[current_v] = V_ID;
		
		//print_N(induced_N, current_v);
		VecOfSets S; S.clear();
		myGraph local_CartRelGraph; /**edges of CartSk(N) to vertices, and connected if in same product-class*/
		myGraph local_CartSk, local_CartSk_eID; /**local_CartSk has edgeID 0, ..., num_edges(CartSk) 
														local_CartSk_eID has same edgeID as N*/
		myGraph thinN;

		int CASE = decompose(induced_N, local_CartSk, local_CartSk_eID, local_CartRelGraph, thinN, S, V_ID);
		//print_local_Factors(local_CartSk, local_CartRelGraph);
		
		if(CASE == 0) {
			++count_Thin_N; 			/**CASE = 0, N thin&notprime  */
			is_thinN[current_v]=true;
		}
		else if(CASE == 1) ++count_nonThin_N; 	/**CASE = 1, N nonThin& not prime*/
		else if(CASE == 2){
			++count_prime_N;		/**CASE = 2, Neigborhood is prime*/
				
		}
		
		/*if(CASE != 2){ choose this, if only non-prime edgeN allowed for local covering and approxProd*/
			//cout << endl << "N" << current_v << "is not Prime";

			bool color_conti = true;
			stepwise_CartesianEdges_and_Colorgraph(G, local_CartSk/*local_CartSk_eID*/, 
												   local_CartRelGraph, induced_N, thinN, S, V_ID, 
												   ColorGraph, all_colors_of_edge, color_conti);
			
			//show_local_S_class(local_CartSk,  S, V_ID);
			if(!color_conti){
				// cout << endl << "ColorConti fails";
				 proper_color_conti = false;
				
				//if(is_thinN[sigma[i-1]] &&  is_thinN[sigma[i]]) {
					/*cout	 << sigma[i-1] << "," << sigma[i] << "N are thin";*/
					/*here todo: CHECK if Nx, and Ny are thin - then search coord and hypercube. 
					- not implemented till now*/
				//} //end if
				//else{	
					/*cout << endl << "CHECK if xy is non-disp - then edgeNxy";
					cout << endl << "TODO: color-conti on edgeN, if (" << 
					sigma[i-1] << "," << sigma[i] << ") is Cartesian, else N*" ;*/
					for(unsigned int l =0; l<i;l++){
						if(edge(sigma[i],sigma[l],G).second){
							//cout << "check edge N" << sigma[i] <<"-" <<sigma[l];
							/*!!!!!!for approximation use only, if edgeN nonPrime!!*/	
							checkDispens_in_edgeN_and_PFD(N,sigma[l],sigma[i],G,all_colors_of_edge,ColorGraph); 
							count_edgeN++;
						}
					}				

					/**test first edgeN, later "N*" */
					/* will bedone at the end: 
						PFD_N_star(N,sigma[i-1],sigma[i],G,all_colors_of_edge,ColorGraph); */
					
				//} //end else
			}
			
		/*} end if(CASE != 2){ das rein, wenn only non-prime edgeN allowed for approx*/
	}

	vector<myGraph> new_factors;
	myGraph CartSk(num_vertices(G));
	myGraph CartSk_edgeID(num_vertices(G));
	init_cart_skeleton_graph(G, CartSk, CartSk_edgeID);
	myGraph CartRelGraph(num_edges(CartSk));
	init_RelGraph(G, CartSk,  CartSk_edgeID, CartRelGraph, ColorGraph, all_colors_of_edge);

/***********************************************/
/*Wed 26 May 2010 02:34:43 PM CEST */
	clear_graph(ColoredCartSk);
	for(unsigned int i =0 ;i<num_vertices(CartSk);i++)
		add_vertex(ColoredCartSk);

	
	new_factors.clear();
	take_biggest_colored_component_as_factor(G, CartSk, CartRelGraph, new_factors, ColoredCartSk);
	print_approxFactors(new_factors);
/*Wed 26 May 2010 02:34:43 PM CEST */	
/***********************************************/


	cout << endl << endl << ">>> PFD of Nstar applied now, if necessary <<<" << endl;
	/**init both :  global CartSkedgeID und CartSK_einfach  by adding all edges of G with weight = 1 + edgeID of G*/
	init_cart_skeleton_graph_afterHammack(G, CartSk, CartSk_edgeID);
	init_RelGraph(G, CartSk,  CartSk_edgeID, CartRelGraph, ColorGraph, all_colors_of_edge);	

	int count_Nstar = 0;
	myEdgeW weightG = get(edge_weight, G);


	eIt ei, ei_end;
	for(tie(ei,ei_end) = edges(G); ei!=ei_end; ei++){
		if(get(weightG, *ei) == 2){
			/*cout << endl << *ei << " - " << get(weightG, *ei);*/
			cout << endl << "check N* of " << *ei;
			++count_Nstar;
			/*!!!!!!for approximation use only, if N_star nonPrime!!*/		
			PFD_N_star(N,source(*ei,G),target(*ei,G),G,all_colors_of_edge,ColorGraph); 
		}
	}
		
	if(count_Nstar>0){
		init_cart_skeleton_graph_afterHammack(G, CartSk, CartSk_edgeID);
		init_RelGraph(G, CartSk,  CartSk_edgeID, CartRelGraph, ColorGraph, all_colors_of_edge);
	}


	print_end_local(proper_color_conti,count_Thin_N,count_nonThin_N, count_prime_N, count_Nstar, count_edgeN);
	

	vector<int> component(num_vertices(CartRelGraph)); 
	int numFactors = connected_components(CartRelGraph, &component[0]);
	new_factors.clear();

	//cout << endl << " RG " << endl;
	//print_graph(CartRelGraph);
	//vector<myGraph> approxFactors;
	//approxFactors.clear();

	vector< vector<int> > coord_vert;
	init_coordinates(CartSk, CartRelGraph, coord_vert, false);
	/*cout << endl << endl << ">>> Extracted Factors of Cartesian Skeleton <<<" << endl;
					cout << ">>> = APPROXIMATE FACTORS of G              <<<" << endl;*/
	bool printIt = false;
	//bool printIt = true;
	init_factor_corresponding_to_coordinates(coord_vert, CartSk, numFactors, new_factors, printIt);
	
	/**look @ primeNICE1.dat here CartSk after local approach does not span G, since only nonPrime-regions are used*/
	bool is_ok = check_if_CartSk_covers_G(CartSk);
	
	if(numFactors>1 && is_ok/* && num_vertices(G) == num_vertices(CartSk)*/){
		//approxFactors = new_factors;
		cout << endl << ">>> Check and Combine Factors <<<" << endl;
		check_and_combineFactors(G,CartSk,CartSk_edgeID,CartRelGraph,coord_vert,component,numFactors,new_factors);
	}
	else{
		cout << endl <<">>> only one Factor found --> G=H/S is prime <<<";
		new_factors.clear();
		new_factors.push_back(G);
		printPFD(gcd,new_factors);
		return 0;
	}
	
	//cout << endl <<  "check and combine again" << endl;
	if(!pumped_up && is_ok)
		printPFD(gcd,new_factors);
	
	else if(is_ok){/**TODO::pomp_up*/
		vector<myGraph> tmp_new_factors;
		for(unsigned int i = 0; i<new_factors.size();i++)
			tmp_new_factors.push_back(new_factors[i]);
		
		if(new_factors.size()==0) tmp_new_factors.push_back(G);
			
		bool pompup_succeed = false;	
		
		pomp_up(how_many, coord_vert, new_factors, pompup_succeed, tmp_new_factors);
		if(!pompup_succeed){
			POMPUP_check_and_combine(G, CartSk, CartSk_edgeID, CartRelGraph, coord_vert, component, 
									 numFactors, new_factors, how_many);
			if(new_factors.size()==0) new_factors.push_back(G);
			printPFD(gcd,new_factors);
		}
		else printPFD(gcd,tmp_new_factors);
	} 
	

 	return 0;

}



